<?php
/*##################################################
 *                        series_common.php
 *                            -------------------
 *   begin                : 27 Novembre 2014
 *   copyright            : (C) 2014 Root
 *   email                : contact@graphismeo.ovh
 *
 *
 ###################################################
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/

#####################################################
 #                      English			    #
 ####################################################

//title
$lang['series'] = 'Series';
$lang['module_config_title'] = 'Series configuration';
$lang['series_management'] = 'Series management';
$lang['series.add'] = 'Add an serie';
$lang['series.edit'] = 'Edit an serie';
$lang['series.delete'] = 'Delete an serie';
$lang['series.visitor'] = 'Visitor';
$lang['series.no_serie'] = 'No available serie';
$lang['series.no_notes'] = 'No notes';
$lang['series.nbr_series_category'] = ':number serie(s) in this category';
$lang['series.sub_categories'] = 'Sub-categories';
$lang['series.category'] = 'Category';
$lang['series.feed_name'] = 'Last series';
$lang['series.pending_series'] = 'Pending series';
$lang['series.nbr_series.pending'] = ':number serie(s) pending';
$lang['series.published_series'] = 'Published series';
$lang['series.select_page'] = 'Select a page';
$lang['series.sources'] = 'Source(s)';
$lang['series.summary'] = 'Summary :';
$lang['series.not_published'] = 'This serie is not yet published or is no more published';
$lang['series.print.serie'] = 'Print an serie';
$lang['series.tags'] = 'Keywords (tags)';
$lang['series.read_more'] = 'Read more...';
$lang['series.date_updated'] = 'Last modification : ';

$lang['series.message.no_items'] = 'No series available for the moment';

//Series configuration
$lang['series_configuration.number_series_per_page'] = 'Maximum number of series displayed';
$lang['series_configuration.number_categories_per_page'] = 'Maximum number of categories displayed';
$lang['series_configuration.display_icon_cats'] = 'Dipslay categories icon';
$lang['series_configuration.number_cols_display_cats'] = 'Number of columns to display categories';
$lang['series_configuration.number_character_to_cut'] = 'Maximum number of characters to cut the serie\'s description';
$lang['series_configuration.display_type'] = 'Display type';
$lang['series_configuration.display_type.mosaic'] = 'Mosaic';
$lang['series_configuration.display_type.list'] = 'List';
$lang['series_configuration.display_type.block'] = 'List without image';
$lang['series_configuration.authorizations.explain'] = 'Global authorizations are defined here for the module. These authorizations can be modified individually for each category';

//Form
$lang['series.form.title'] = 'Title';
$lang['series.form.description'] = 'Description (maximum :number characters)';
$lang['series.form.description_enabled'] = 'Enable serie description';
$lang['series.form.description_enabled.description'] = 'or let PHPBoost cut the content at :number characters';
$lang['series.form.rewrited_title'] = 'Serie title in the url';
$lang['series.form.rewrited_title.personalize'] = 'Personalize the serie title in the url';
$lang['series.form.rewrited_title.description'] = 'Only lowercase characters, numerals and hyphens are accepted';
$lang['series.form.add_page'] = 'Insert a page';
$lang['series.form.add_page.title'] = 'New page title';
$lang['series.form.author_name_displayed'] = 'Display author\'s name';
$lang['series.form.notation_enabled'] = 'Enable notation';
$lang['series.form.picture'] = 'Serie\'s picture';
$lang['series.form.picture.description'] = 'Select a picture or type an url';
$lang['series.form.keywords.description'] = 'Add keywords (tags) to your serie';
$lang['series.form.source_name'] = 'Source name';
$lang['series.form.source_url'] = 'Source url';
$lang['series.form.contribution_entitled'] = '[Serie] :title';

//Sort fields title and mode
$lang['series.sort_filter_title'] = 'Sort by :';
$lang['series.sort_field.date'] = 'Date';
$lang['series.sort_field.title'] = 'Title';
$lang['series.sort_field.views'] = 'Views';
$lang['series.sort_field.com'] = 'Comment';
$lang['series.sort_field.note'] = 'Note';
$lang['series.sort_field.author'] = 'Author';
$lang['series.sort_mode.asc'] = 'Ascending';
$lang['series.sort_mode.desc'] = 'Descending';

$lang['admin.series.sort_field.cat'] = 'Categories';
$lang['admin.series.sort_field.title'] = 'Title';
$lang['admin.series.sort_field.author'] = 'Author';
$lang['admin.series.sort_field.date'] = 'Date';
$lang['admin.series.sort_field.published'] = 'Published';

//SEO
$lang['series.seo.description.root'] = 'All :site\'s series.';
$lang['series.seo.description.tag'] = 'All :subject\'s series.';
$lang['series.seo.description.pending'] = 'All pending series.';

$lang['series.episode1'] = 'Episode VF 1:';
$lang['series.episode2'] = 'Episode VF 2:';
$lang['series.episode3'] = 'Episode VF 3:';
$lang['series.episode4'] = 'Episode VF 4:';
$lang['series.episode5'] = 'Épisode VF 5:';
$lang['series.episode6'] = 'Épisode VF 6:';
$lang['series.episode7'] = 'Épisode VF 7:';
$lang['series.episode8'] = 'Épisode VF 8:';
$lang['series.episode9'] = 'Épisode VF 9:';
$lang['series.episode10'] = 'Épisode VF 10:';
$lang['series.episode11'] = 'Épisode VF 11:';
$lang['series.episode12'] = 'Épisode VF 12:';
$lang['series.episode13'] = 'Épisode VF 13:';
$lang['series.episode14'] = 'Épisode VF 14:';
$lang['series.episode15'] = 'Épisode VF 15:';
$lang['series.episode16'] = 'Épisode VF 16:';
$lang['series.episode17'] = 'Épisode VF 17:';
$lang['series.episode18'] = 'Épisode VF 18:';
$lang['series.episode19'] = 'Épisode VF 19:';
$lang['series.episode20'] = 'Épisode VF 20:';
$lang['series.episode21'] = 'Épisode VF 21:';
$lang['series.episode22'] = 'Épisode VF 22:';
$lang['series.episode23'] = 'Épisode VF 23:';
$lang['series.episode24'] = 'Épisode VF 24:';
$lang['series.episode25'] = 'Épisode VF 25:';
$lang['series.episode26'] = 'Épisode VF 26:';
$lang['series.episode27'] = 'Épisode VF 27:';
$lang['series.episode28'] = 'Épisode VF 28:';
$lang['series.episode29'] = 'Épisode VF 29:';
$lang['series.episode30'] = 'Épisode VF 30:';
$lang['series.episode31'] = 'Épisode VF 31:';
$lang['series.episode32'] = 'Épisode VF 32:';
$lang['series.episode33'] = 'Épisode VF 33:';
$lang['series.episode34'] = 'Épisode VF 34:';
$lang['series.episode35'] = 'Épisode VF 35:';
$lang['series.episode36'] = 'Épisode VF 36:';
$lang['series.episode37'] = 'Épisode VF 37:';
$lang['series.episode38'] = 'Épisode VF 38:';
$lang['series.episode39'] = 'Épisode VF 39:';
$lang['series.episode40'] = 'Épisode VF 40:';
$lang['series.episodevostfr1'] = 'Épisode VOSTFR 1:';
$lang['series.episodevostfr2'] = 'Épisode VOSTFR 2:';
$lang['series.episodevostfr3'] = 'Épisode VOSTFR 3:';
$lang['series.episodevostfr4'] = 'Épisode VOSTFR 4:';
$lang['series.episodevostfr5'] = 'Épisode VOSTFR 5:';
$lang['series.episodevostfr6'] = 'Épisode VOSTFR 6:';
$lang['series.episodevostfr7'] = 'Épisode VOSTFR 7:';
$lang['series.episodevostfr8'] = 'Épisode VOSTFR 8:';
$lang['series.episodevostfr9'] = 'Épisode VOSTFR 9:';
$lang['series.episodevostfr10'] = 'Épisode VOSTFR 10:';
$lang['series.episodevostfr11'] = 'Épisode VOSTFR 11:';
$lang['series.episodevostfr12'] = 'Épisode VOSTFR 12:';
$lang['series.episodevostfr13'] = 'Épisode VOSTFR 13:';
$lang['series.episodevostfr14'] = 'Épisode VOSTFR 14:';
$lang['series.episodevostfr15'] = 'Épisode VOSTFR 15:';
$lang['series.episodevostfr16'] = 'Épisode VOSTFR 16:';
$lang['series.episodevostfr17'] = 'Épisode VOSTFR 17:';
$lang['series.episodevostfr18'] = 'Épisode VOSTFR 18:';
$lang['series.episodevostfr19'] = 'Épisode VOSTFR 19:';
$lang['series.episodevostfr20'] = 'Épisode VOSTFR 20:';
$lang['series.episodevostfr21'] = 'Épisode VOSTFR 21:';
$lang['series.episodevostfr22'] = 'Épisode VOSTFR 22:';
$lang['series.episodevostfr23'] = 'Épisode VOSTFR 23:';
$lang['series.episodevostfr24'] = 'Épisode VOSTFR 24:';
$lang['series.episodevostfr25'] = 'Épisode VOSTFR 25:';
$lang['series.episodevostfr26'] = 'Épisode VOSTFR 26:';
$lang['series.episodevostfr27'] = 'Épisode VOSTFR 27:';
$lang['series.episodevostfr28'] = 'Épisode VOSTFR 28:';
$lang['series.episodevostfr29'] = 'Épisode VOSTFR 29:';
$lang['series.episodevostfr30'] = 'Épisode VOSTFR 30:';
$lang['series.episodevostfr31'] = 'Épisode VOSTFR 31:';
$lang['series.episodevostfr32'] = 'Épisode VOSTFR 32:';
$lang['series.episodevostfr33'] = 'Épisode VOSTFR 33:';
$lang['series.episodevostfr34'] = 'Épisode VOSTFR 34:';
$lang['series.episodevostfr35'] = 'Épisode VOSTFR 35:';
$lang['series.episodevostfr36'] = 'Épisode VOSTFR 36:';
$lang['series.episodevostfr37'] = 'Épisode VOSTFR 37:';
$lang['series.episodevostfr38'] = 'Épisode VOSTFR 38:';
$lang['series.episodevostfr39'] = 'Épisode VOSTFR 39:';
$lang['series.episodevostfr40'] = 'Épisode VOSTFR 40:';
?>

?>