<?php
/*##################################################
 *                        Serie.class.php
 *                            -------------------
 *   begin                : February 27, 2013
 *   copyright            : (C) 2014 Root
 *   email                : contact@graphismeo.ovh
 *
 *
 ###################################################
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/

/**
 * @author Patrick DUBEAU <daaxwizeman@gmail.com>
 */
class Serie
{
	private $id;
	private $id_category;
	private $title;
	private $rewrited_title;
	private $description;
	private $contents;
	private $picture_url;
	private $number_view;

	private $notation_enabled;
	private $author_name_displayed;
	private $author_user;
	private $notation;
	private $keywords;

	private $published;
	private $publishing_start_date;
	private $publishing_end_date;
	private $date_created;
	private $end_date_enabled;
	private $date_updated;
	private $episode1;
	private $episode2;
	private $episode3;
	private $episode4;
	private $episode5;
	private $episode6;
	private $episode7;
	private $episode8;
	private $episode9;
	private $episode10;
	private $episode11;
	private $episode12;
	private $episode13;
	private $episode14;
	private $episode15;
	private $episode16;
	private $episode17;
	private $episode18;
	private $episode19;
	private $episode20;
	private $episode21;
	private $episode22;
	private $episode23;
	private $episode24;
	private $episode25;
	private $episode26;
	private $episode27;
	private $episode28;
	private $episode29;
	private $episode30;
	private $episode31;
	private $episode32;
	private $episode33;
	private $episode34;
	private $episode35;
	private $episode36;
	private $episode37;
	private $episode38;
	private $episode39;
	private $episode40;
	private $episodevostfr1;
	private $episodevostfr2;
	private $episodevostfr3;
	private $episodevostfr4;
	private $episodevostfr5;
	private $episodevostfr6;
	private $episodevostfr7;
	private $episodevostfr8;
	private $episodevostfr9;
	private $episodevostfr10;
	private $episodevostfr11;
	private $episodevostfr12;
	private $episodevostfr13;
	private $episodevostfr14;
	private $episodevostfr15;
	private $episodevostfr16;
	private $episodevostfr17;
	private $episodevostfr18;
	private $episodevostfr19;
	private $episodevostfr20;
	private $episodevostfr21;
	private $episodevostfr22;
	private $episodevostfr23;
	private $episodevostfr24;
	private $episodevostfr25;
	private $episodevostfr26;
	private $episodevostfr27;
	private $episodevostfr28;
	private $episodevostfr29;
	private $episodevostfr30;
	private $episodevostfr31;
	private $episodevostfr32;
	private $episodevostfr33;
	private $episodevostfr34;
	private $episodevostfr35;
	private $episodevostfr36;
	private $episodevostfr37;
	private $episodevostfr38;
	private $episodevostfr39;
	private $episodevostfr40;
	private $acteurs;
	private $duree;
	private $statut;
	private $annee;

	const NOT_PUBLISHED = 0;
	const PUBLISHED_NOW = 1;
	const PUBLISHED_DATE = 2;

	const NOTATION_DISABLED = 0;
	const NOTATION_ENABLED = 1;

	const AUTHOR_NAME_NOTDISPLAYED = 0;
	const AUTHOR_NAME_DISPLAYED = 1;
        
	const DEFAULT_PICTURE = '/series/templates/images/default.png';

	public function set_id($id)
	{
		$this->id = $id;
	}

	public function get_id()
	{
		return $this->id;
	}

	public function set_id_category($id_category)
	{
		$this->id_category = $id_category;
	}

	public function get_id_category()
	{
		return $this->id_category;
	}

	public function set_title($title)
	{
		$this->title = $title;
	}

	public function get_title()
	{
		return $this->title;
	}

	public function get_keywords()
	{
		if ($this->keywords === null)
		{
			$this->keywords = ArticlesService::get_keywords_manager()->get_keywords($this->id);
		}
	return $this->keywords;
	}
	
	public function get_keywords_name()
	{
		return array_keys($this->get_keywords());
	}
	public function set_episode1($episode1)
	{
		$this->episode1 = $episode1;
	}

	public function get_episode1()
	{
		return $this->episode1;
	}
	
	public function set_episode2($episode2)
	{
		$this->episode2 = $episode2;
	}

	public function get_episode2()
	{
		return $this->episode2;
	}
	public function set_episode3($episode3)
	{
		$this->episode3 = $episode3;
	}
	public function get_episode3()
	{
		return $this->episode3;
	}
		public function set_episode4($episode4)
	{
		$this->episode4 = $episode4;
	}

	public function get_episode4()
	{
		return $this->episode4;
	}
	
	public function set_episode5($episode5)
	{
		$this->episode5 = $episode5;
	}

	public function get_episode5()
	{
		return $this->episode5;
	}
	public function set_episode6($episode6)
	{
		$this->episode6 = $episode6;
	}

	public function get_episode6()
	{
		return $this->episode6;
	}
	
	public function set_episode7($episode7)
	{
		$this->episode7 = $episode7;
	}

	public function get_episode7()
	{
		return $this->episode7;
	}
	public function set_episode8($episode8)
	{
		$this->episode8 = $episode8;
	}

	public function get_episode8()
	{
		return $this->episode8;
	}
	
	public function set_episode9($episode9)
	{
		$this->episode9 = $episode9;
	}

	public function get_episode9()
	{
		return $this->episode9;
	}
	public function set_episode10($episode10)
	{
		$this->episode10 = $episode10;
	}

	public function get_episode10()
	{
		return $this->episode10;
	}
	
	public function set_episode11($episode11)
	{
		$this->episode11 = $episode11;
	}

	public function get_episode11()
	{
		return $this->episode11;
	}
	public function set_episode12($episode12)
	{
		$this->episode12 = $episode12;
	}

	public function get_episode12()
	{
		return $this->episode12;
	}
	
	public function set_episode13($episode13)
	{
		$this->episode13 = $episode13;
	}

	public function get_episode13()
	{
		return $this->episode13;
	}
	public function set_episode14($episode14)
	{
		$this->episode14 = $episode14;
	}

	public function get_episode14()
	{
		return $this->episode14;
	}
	
	public function set_episode15($episode15)
	{
		$this->episode15 = $episode15;
	}

	public function get_episode15()
	{
		return $this->episode15;
	}
	public function set_episode16($episode16)
	{
		$this->episode16 = $episode16;
	}

	public function get_episode16()
	{
		return $this->episode16;
	}
	
	public function set_episode17($episode17)
	{
		$this->episode17 = $episode17;
	}

	public function get_episode17()
	{
		return $this->episode17;
	}
	public function set_episode18($episode18)
	{
		$this->episode18 = $episode18;
	}

	public function get_episode18()
	{
		return $this->episode18;
	}
	
	public function set_episode19($episode19)
	{
		$this->episode19 = $episode19;
	}

	public function get_episode19()
	{
		return $this->episode19;
	}
	public function set_episode20($episode20)
	{
		$this->episode20 = $episode20;
	}

	public function get_episode20()
	{
		return $this->episode20;
	}
	
	public function set_episode21($episode21)
	{
		$this->episode21 = $episode21;
	}

	public function get_episode21()
	{
		return $this->episode21;
	}
	public function set_episode22($episode22)
	{
		$this->episode22 = $episode22;
	}

	public function get_episode22()
	{
		return $this->episode22;
	}
	
	public function set_episode23($episode23)
	{
		$this->episode23 = $episode23;
	}

	public function get_episode23()
	{
		return $this->episode23;
	}
	public function set_episode24($episode24)
	{
		$this->episode24 = $episode24;
	}

	public function get_episode24()
	{
		return $this->episode24;
	}
	
	public function set_episode25($episode25)
	{
		$this->episode25 = $episode25;
	}

	public function get_episode25()
	{
		return $this->episode25;
	}
	public function set_episode26($episode26)
	{
		$this->episode26 = $episode26;
	}

	public function get_episode26()
	{
		return $this->episode26;
	}
	
	public function set_episode27($episode27)
	{
		$this->episode27 = $episode27;
	}

	public function get_episode27()
	{
		return $this->episode27;
	}
	public function set_episode28($episode28)
	{
		$this->episode28 = $episode28;
	}

	public function get_episode28()
	{
		return $this->episode28;
	}
	
	public function set_episode29($episode29)
	{
		$this->episode29 = $episode29;
	}

	public function get_episode29()
	{
		return $this->episode29;
	}
	public function set_episode30($episode30)
	{
		$this->episode30 = $episode30;
	}

	public function get_episode30()
	{
		return $this->episode30;
	}
	
	public function set_episode31($episode31)
	{
		$this->episode31 = $episode31;
	}

	public function get_episode31()
	{
		return $this->episode31;
	}
	public function set_episode32($episode32)
	{
		$this->episode32 = $episode32;
	}

	public function get_episode32()
	{
		return $this->episode32;
	}
	
	public function set_episode33($episode33)
	{
		$this->episode33 = $episode33;
	}

	public function get_episode33()
	{
		return $this->episode33;
	}
	public function set_episode34($episode34)
	{
		$this->episode34 = $episode34;
	}

	public function get_episode34()
	{
		return $this->episode34;
	}
	
	public function set_episode35($episode35)
	{
		$this->episode35 = $episode35;
	}

	public function get_episode35()
	{
		return $this->episode35;
	}
	public function set_episode36($episode36)
	{
		$this->episode36 = $episode36;
	}

	public function get_episode36()
	{
		return $this->episode36;
	}
	
	public function set_episode37($episode37)
	{
		$this->episode37 = $episode37;
	}

	public function get_episode37()
	{
		return $this->episode37;
	}
	public function set_episode38($episode38)
	{
		$this->episode38 = $episode38;
	}

	public function get_episode38()
	{
		return $this->episode38;
	}
	
	public function set_episode39($episode39)
	{
		$this->episode39 = $episode39;
	}

	public function get_episode39()
	{
		return $this->episode39;
	}
	public function set_episode40($episode40)
	{
		$this->episode40 = $episode40;
	}

	public function get_episode40()
	{
		return $this->episode40;
	}
	public function set_episodevostfr1($episodevostfr1)
	{
		$this->episodevostfr1 = $episodevostfr1;
	}

	public function get_episodevostfr1()
	{
		return $this->episodevostfr1;
	}
	
	public function set_episodevostfr2($episodevostfr2)
	{
		$this->episodevostfr2 = $episodevostfr2;
	}

	public function get_episodevostfr2()
	{
		return $this->episodevostfr2;
	}
	public function set_episodevostfr3($episodevostfr3)
	{
		$this->episodevostfr3 = $episodevostfr3;
	}
	public function get_episodevostfr3()
	{
		return $this->episodevostfr3;
	}
	public function set_episodevostfr4($episodevostfr4)
	{
		$this->episodevostfr4 = $episodevostfr4;
	}

	public function get_episodevostfr4()
	{
		return $this->episodevostfr4;
	}
	
	public function set_episodevostfr5($episodevostfr5)
	{
		$this->episodevostfr5 = $episodevostfr5;
	}

	public function get_episodevostfr5()
	{
		return $this->episodevostfr5;
	}
	public function set_episodevostfr6($episodevostfr6)
	{
		$this->episodevostfr6 = $episodevostfr6;
	}

	public function get_episodevostfr6()
	{
		return $this->episodevostfr6;
	}
	
	public function set_episodevostfr7($episodevostfr7)
	{
		$this->episodevostfr7 = $episodevostfr7;
	}

	public function get_episodevostfr7()
	{
		return $this->episodevostfr7;
	}
	public function set_episodevostfr8($episodevostfr8)
	{
		$this->episodevostfr8 = $episodevostfr8;
	}

	public function get_episodevostfr8()
	{
		return $this->episodevostfr8;
	}
	
	public function set_episodevostfr9($episodevostfr9)
	{
		$this->episodevostfr9 = $episodevostfr9;
	}

	public function get_episodevostfr9()
	{
		return $this->episodevostfr9;
	}
	public function set_episodevostfr10($episodevostfr10)
	{
		$this->episodevostfr10 = $episodevostfr10;
	}

	public function get_episodevostfr10()
	{
		return $this->episodevostfr10;
	}
	
	public function set_episodevostfr11($episodevostfr11)
	{
		$this->episodevostfr11 = $episodevostfr11;
	}

	public function get_episodevostfr11()
	{
		return $this->episodevostfr11;
	}
	public function set_episodevostfr12($episodevostfr12)
	{
		$this->episodevostfr12 = $episodevostfr12;
	}

	public function get_episodevostfr12()
	{
		return $this->episodevostfr12;
	}
	
	public function set_episodevostfr13($episodevostfr13)
	{
		$this->episodevostfr13 = $episodevostfr13;
	}

	public function get_episodevostfr13()
	{
		return $this->episodevostfr13;
	}
	public function set_episodevostfr14($episodevostfr14)
	{
		$this->episodevostfr14 = $episodevostfr14;
	}

	public function get_episodevostfr14()
	{
		return $this->episodevostfr14;
	}
	
	public function set_episodevostfr15($episodevostfr15)
	{
		$this->episodevostfr15 = $episodevostfr15;
	}

	public function get_episodevostfr15()
	{
		return $this->episodevostfr15;
	}
	public function set_episodevostfr16($episodevostfr16)
	{
		$this->episodevostfr16 = $episodevostfr16;
	}

	public function get_episodevostfr16()
	{
		return $this->episodevostfr16;
	}
	
	public function set_episodevostfr17($episodevostfr17)
	{
		$this->episodevostfr17 = $episodevostfr17;
	}

	public function get_episodevostfr17()
	{
		return $this->episodevostfr17;
	}
	public function set_episodevostfr18($episodevostfr18)
	{
		$this->episodevostfr18 = $episodevostfr18;
	}

	public function get_episodevostfr18()
	{
		return $this->episodevostfr18;
	}
	
	public function set_episodevostfr19($episodevostfr19)
	{
		$this->episodevostfr19 = $episodevostfr19;
	}

	public function get_episodevostfr19()
	{
		return $this->episodevostfr19;
	}
	public function set_episodevostfr20($episodevostfr20)
	{
		$this->episodevostfr20 = $episodevostfr20;
	}

	public function get_episodevostfr20()
	{
		return $this->episodevostfr20;
	}
	
	public function set_episodevostfr21($episodevostfr21)
	{
		$this->episodevostfr21 = $episodevostfr21;
	}

	public function get_episodevostfr21()
	{
		return $this->episodevostfr21;
	}
	public function set_episodevostfr22($episodevostfr22)
	{
		$this->episodevostfr22 = $episodevostfr22;
	}

	public function get_episodevostfr22()
	{
		return $this->episodevostfr22;
	}
	
	public function set_episodevostfr23($episodevostfr23)
	{
		$this->episodevostfr23 = $episodevostfr23;
	}

	public function get_episodevostfr23()
	{
		return $this->episodevostfr23;
	}
	public function set_episodevostfr24($episodevostfr24)
	{
		$this->episodevostfr24 = $episodevostfr24;
	}

	public function get_episodevostfr24()
	{
		return $this->episodevostfr24;
	}
	
	public function set_episodevostfr25($episodevostfr25)
	{
		$this->episodevostfr25 = $episodevostfr25;
	}

	public function get_episodevostfr25()
	{
		return $this->episodevostfr25;
	}
	public function set_episodevostfr26($episodevostfr26)
	{
		$this->episodevostfr26 = $episodevostfr26;
	}

	public function get_episodevostfr26()
	{
		return $this->episodevostfr26;
	}
	
	public function set_episodevostfr27($episodevostfr27)
	{
		$this->episodevostfr27 = $episodevostfr27;
	}

	public function get_episodevostfr27()
	{
		return $this->episodevostfr27;
	}
	public function set_episodevostfr28($episodevostfr28)
	{
		$this->episodevostfr28 = $episodevostfr28;
	}

	public function get_episodevostfr28()
	{
		return $this->episodevostfr28;
	}
	
	public function set_episodevostfr29($episodevostfr29)
	{
		$this->episodevostfr29 = $episodevostfr29;
	}

	public function get_episodevostfr29()
	{
		return $this->episodevostfr29;
	}
	public function set_episodevostfr30($episodevostfr30)
	{
		$this->episodevostfr30 = $episodevostfr30;
	}

	public function get_episodevostfr30()
	{
		return $this->episodevostfr30;
	}
	
	public function set_episodevostfr31($episodevostfr31)
	{
		$this->episodevostfr31 = $episodevostfr31;
	}

	public function get_episodevostfr31()
	{
		return $this->episodevostfr31;
	}
	public function set_episodevostfr32($episodevostfr32)
	{
		$this->episodevostfr32 = $episodevostfr32;
	}

	public function get_episodevostfr32()
	{
		return $this->episodevostfr32;
	}
	
	public function set_episodevostfr33($episodevostfr33)
	{
		$this->episodevostfr33 = $episodevostfr33;
	}

	public function get_episodevostfr33()
	{
		return $this->episodevostfr33;
	}
	public function set_episodevostfr34($episodevostfr34)
	{
		$this->episodevostfr34 = $episodevostfr34;
	}

	public function get_episodevostfr34()
	{
		return $this->episodevostfr34;
	}
	
	public function set_episodevostfr35($episodevostfr35)
	{
		$this->episodevostfr35 = $episodevostfr35;
	}

	public function get_episodevostfr35()
	{
		return $this->episodevostfr35;
	}
	public function set_episodevostfr36($episodevostfr36)
	{
		$this->episodevostfr36 = $episodevostfr36;
	}

	public function get_episodevostfr36()
	{
		return $this->episodevostfr36;
	}
	
	public function set_episodevostfr37($episodevostfr37)
	{
		$this->episodevostfr37 = $episodevostfr37;
	}

	public function get_episodevostfr37()
	{
		return $this->episodevostfr37;
	}
	public function set_episodevostfr38($episodevostfr38)
	{
		$this->episodevostfr38 = $episodevostfr38;
	}

	public function get_episodevostfr38()
	{
		return $this->episodevostfr38;
	}
	
	public function set_episodevostfr39($episodevostfr39)
	{
		$this->episodevostfr39 = $episodevostfr39;
	}

	public function get_episodevostfr39()
	{
		return $this->episodevostfr39;
	}
	public function set_episodevostfr40($episodevostfr40)
	{
		$this->episodevostfr40 = $episodevostfr40;
	}
	public function get_episodevostfr40()
	{
		return $this->episodevostfr40;
	}
	public function set_acteurs($acteurs)
	{
		$this->acteurs = $acteurs;
	}
	public function get_acteurs()
	{
		return $this->acteurs;
	}
	public function set_statut($statut)
	{
		$this->statut = $statut;
	}
	public function get_statut()
	{
		return $this->statut;
	}
	public function set_annee($annee)
	{
		$this->annee = $annee;
	}
	public function get_annee()
	{
		return $this->annee;
	}
	public function set_duree($duree)
	{
		$this->duree = $duree;
	}
	public function get_duree()
	{
		return $this->duree;
	}
	public function set_rewrited_title($rewrited_title)
	{
		$this->rewrited_title = $rewrited_title;
	}

	public function get_rewrited_title()
	{
		return $this->rewrited_title;
	}

	public function rewrited_title_is_personalized()
	{
		return $this->rewrited_title != Url::encode_rewrite($this->title);
	}
	
	public function set_description($description)
	{
		$this->description = $description;
	}
	
	public function get_description()
	{
		return $this->description;
	}
	
	public function get_description_enabled()
	{
		return !empty($this->description);
	}
	
	public function get_real_description()
	{
		if ($this->get_description_enabled())
		{
			return substr(@strip_tags($this->description, '<br>'), 0, SeriesConfig::load()->get_number_character_to_cut());
		}
		else
		{
			$clean_contents = preg_split('`\[page\].+\[/page\](.*)`Us', $this->contents, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
			return substr(@strip_tags($clean_contents[0], '<br>'), 0, SeriesConfig::load()->get_number_character_to_cut());
		}
	}
	
	public function set_contents($contents)
	{
		$this->contents = $contents;
	}

	public function get_contents()
	{
		return $this->contents;
	}
	
	public function set_picture(Url $picture)
	{
		$this->picture_url = $picture;
	}

	public function get_picture()
	{
		return $this->picture_url;
	}
	
	public function has_picture()
	{
		$picture = $this->picture_url->rel();
		return !empty($picture);
	}
	
	public function set_number_view($number_view)
	{
		$this->number_view = $number_view;
	}

	public function get_number_view()
	{
		return $this->number_view;
	}

	public function get_notation_enabled()
	{
		return $this->notation_enabled;
	}

	public function set_notation_enabled($enabled) 
	{
		$this->notation_enabled = $enabled;
	}

	public function get_author_name_displayed()
	{
		return $this->author_name_displayed;
	}

	public function set_author_name_displayed($displayed)
	{
		$this->author_name_displayed = $displayed;
	}

	public function set_author_user(User $user)
	{
		$this->author_user = $user;
	}
	
	public function get_author_user()
	{
	    return $this->author_user;
	}

	public function set_notation(Notation $notation)
	{
		$this->notation = $notation;
	}
	
	public function get_notation()
	{
	    return $this->notation;
	}
	
	public function set_publishing_state($published)
	{
		$this->published = $published;
	}

	public function get_publishing_state()
	{
		return $this->published;
	}
	
	public function is_published()
	{
		$now = new Date();
		return $this->get_publishing_state() == self::PUBLISHED_NOW || 
			($this->get_publishing_state() == self::PUBLISHED_DATE 
			&& $this->get_publishing_start_date()->is_anterior_to($now) 
			&& ($this->end_date_enabled ? $this->get_publishing_end_date()->is_posterior_to($now) : true));
	}
	
	public function set_publishing_start_date(Date $publishing_start_date)
	{
		$this->publishing_start_date = $publishing_start_date;
	}

	public function get_publishing_start_date()
	{
		return $this->publishing_start_date;
	}

	public function set_publishing_end_date(Date $publishing_end_date)
	{
		$this->publishing_end_date = $publishing_end_date;
		$this->end_date_enabled = true;
	}

	public function get_publishing_end_date()
	{
		return $this->publishing_end_date;
	}

	public function end_date_enabled()
	{
		return $this->end_date_enabled;
	}

	public function set_date_created(Date $date_created)
	{
		$this->date_created = $date_created;
	}

	public function get_date_created()
	{
		return $this->date_created;
	}
	
	public function get_date_updated()
	{
		return $this->date_updated;
	}
	
	public function set_date_updated(Date $date_updated)
	{
	    $this->date_updated = $date_updated;
	}
	
	public function is_authorized_add()
	{
		return SeriesAuthorizationsService::check_authorizations($this->id_category)->write() || SeriesAuthorizationsService::check_authorizations($this->id_category)->contribution();
	}
	
	public function is_authorized_edit()
	{
		return SeriesAuthorizationsService::check_authorizations($this->id_category)->moderation() || ((SeriesAuthorizationsService::check_authorizations($this->get_id_category())->write() || (SeriesAuthorizationsService::check_authorizations($this->get_id_category())->contribution() && !$this->is_published())) && $this->get_author_user()->get_id() == AppContext::get_current_user()->get_id() && AppContext::get_current_user()->check_level(User::MEMBER_LEVEL));
	}
	
	public function is_authorized_delete()
	{
		return SeriesAuthorizationsService::check_authorizations($this->id_category)->moderation() || ((SeriesAuthorizationsService::check_authorizations($this->get_id_category())->write() || (SeriesAuthorizationsService::check_authorizations($this->get_id_category())->contribution() && !$this->is_published())) && $this->get_author_user()->get_id() == AppContext::get_current_user()->get_id() && AppContext::get_current_user()->check_level(User::MEMBER_LEVEL));
	}

	public function get_properties()
	{
		return array(
			'id' => $this->get_id(),
			'id_category' => $this->get_id_category(),
			'title' => TextHelper::htmlspecialchars($this->get_title()),
			'episode1' => TextHelper::htmlspecialchars($this->get_episode1()),
			'episode2' => TextHelper::htmlspecialchars($this->get_episode2()),
			'episode3' => TextHelper::htmlspecialchars($this->get_episode3()),
			'episode4' => TextHelper::htmlspecialchars($this->get_episode4()),
			'episode5' => TextHelper::htmlspecialchars($this->get_episode5()),
			'episode6' => TextHelper::htmlspecialchars($this->get_episode6()),
			'episode7' => TextHelper::htmlspecialchars($this->get_episode7()),
			'episode8' => TextHelper::htmlspecialchars($this->get_episode8()),
			'episode9' => TextHelper::htmlspecialchars($this->get_episode9()),
			'episode10' => TextHelper::htmlspecialchars($this->get_episode10()),
			'episode11' => TextHelper::htmlspecialchars($this->get_episode11()),
			'episode12' => TextHelper::htmlspecialchars($this->get_episode12()),
			'episode13' => TextHelper::htmlspecialchars($this->get_episode13()),
			'episode14' => TextHelper::htmlspecialchars($this->get_episode14()),
			'episode15' => TextHelper::htmlspecialchars($this->get_episode15()),
			'episode16' => TextHelper::htmlspecialchars($this->get_episode16()),
			'episode17' => TextHelper::htmlspecialchars($this->get_episode17()),
			'episode18' => TextHelper::htmlspecialchars($this->get_episode18()),
			'episode19' => TextHelper::htmlspecialchars($this->get_episode19()),
			'episode20' => TextHelper::htmlspecialchars($this->get_episode20()),
			'episode21' => TextHelper::htmlspecialchars($this->get_episode21()),
			'episode22' => TextHelper::htmlspecialchars($this->get_episode22()),
			'episode23' => TextHelper::htmlspecialchars($this->get_episode23()),
			'episode24' => TextHelper::htmlspecialchars($this->get_episode24()),
			'episode25' => TextHelper::htmlspecialchars($this->get_episode25()),
			'episode26' => TextHelper::htmlspecialchars($this->get_episode26()),
			'episode27' => TextHelper::htmlspecialchars($this->get_episode27()),
			'episode28' => TextHelper::htmlspecialchars($this->get_episode28()),
			'episode29' => TextHelper::htmlspecialchars($this->get_episode29()),
			'episode30' => TextHelper::htmlspecialchars($this->get_episode30()),
			'episode31' => TextHelper::htmlspecialchars($this->get_episode31()),
			'episode32' => TextHelper::htmlspecialchars($this->get_episode32()),
			'episode33' => TextHelper::htmlspecialchars($this->get_episode33()),
			'episode34' => TextHelper::htmlspecialchars($this->get_episode34()),
			'episode35' => TextHelper::htmlspecialchars($this->get_episode35()),
			'episode36' => TextHelper::htmlspecialchars($this->get_episode36()),
			'episode37' => TextHelper::htmlspecialchars($this->get_episode37()),
			'episode38' => TextHelper::htmlspecialchars($this->get_episode38()),
			'episode39' => TextHelper::htmlspecialchars($this->get_episode39()),
			'episode40' => TextHelper::htmlspecialchars($this->get_episode40()),
			'episodevostfr1' => TextHelper::htmlspecialchars($this->get_episodevostfr1()),
			'episodevostfr2' => TextHelper::htmlspecialchars($this->get_episodevostfr2()),
			'episodevostfr3' => TextHelper::htmlspecialchars($this->get_episodevostfr3()),
			'episodevostfr4' => TextHelper::htmlspecialchars($this->get_episodevostfr4()),
			'episodevostfr5' => TextHelper::htmlspecialchars($this->get_episodevostfr5()),
			'episodevostfr6' => TextHelper::htmlspecialchars($this->get_episodevostfr6()),
			'episodevostfr7' => TextHelper::htmlspecialchars($this->get_episodevostfr7()),
			'episodevostfr8' => TextHelper::htmlspecialchars($this->get_episodevostfr8()),
			'episodevostfr9' => TextHelper::htmlspecialchars($this->get_episodevostfr9()),
			'episodevostfr10' => TextHelper::htmlspecialchars($this->get_episodevostfr10()),
			'episodevostfr11' => TextHelper::htmlspecialchars($this->get_episodevostfr11()),
			'episodevostfr12' => TextHelper::htmlspecialchars($this->get_episodevostfr12()),
			'episodevostfr13' => TextHelper::htmlspecialchars($this->get_episodevostfr13()),
			'episodevostfr14' => TextHelper::htmlspecialchars($this->get_episodevostfr14()),
			'episodevostfr15' => TextHelper::htmlspecialchars($this->get_episodevostfr15()),
			'episodevostfr16' => TextHelper::htmlspecialchars($this->get_episodevostfr16()),
			'episodevostfr17' => TextHelper::htmlspecialchars($this->get_episodevostfr17()),
			'episodevostfr18' => TextHelper::htmlspecialchars($this->get_episodevostfr18()),
			'episodevostfr19' => TextHelper::htmlspecialchars($this->get_episodevostfr19()),
			'episodevostfr20' => TextHelper::htmlspecialchars($this->get_episodevostfr20()),
			'episodevostfr21' => TextHelper::htmlspecialchars($this->get_episodevostfr21()),
			'episodevostfr22' => TextHelper::htmlspecialchars($this->get_episodevostfr22()),
			'episodevostfr23' => TextHelper::htmlspecialchars($this->get_episodevostfr23()),
			'episodevostfr24' => TextHelper::htmlspecialchars($this->get_episodevostfr24()),
			'episodevostfr25' => TextHelper::htmlspecialchars($this->get_episodevostfr25()),
			'episodevostfr26' => TextHelper::htmlspecialchars($this->get_episodevostfr26()),
			'episodevostfr27' => TextHelper::htmlspecialchars($this->get_episodevostfr27()),
			'episodevostfr28' => TextHelper::htmlspecialchars($this->get_episodevostfr28()),
			'episodevostfr29' => TextHelper::htmlspecialchars($this->get_episodevostfr29()),
			'episodevostfr30' => TextHelper::htmlspecialchars($this->get_episodevostfr30()),
			'episodevostfr31' => TextHelper::htmlspecialchars($this->get_episodevostfr31()),
			'episodevostfr32' => TextHelper::htmlspecialchars($this->get_episodevostfr32()),
			'episodevostfr33' => TextHelper::htmlspecialchars($this->get_episodevostfr33()),
			'episodevostfr34' => TextHelper::htmlspecialchars($this->get_episodevostfr34()),
			'episodevostfr35' => TextHelper::htmlspecialchars($this->get_episodevostfr35()),
			'episodevostfr36' => TextHelper::htmlspecialchars($this->get_episodevostfr36()),
			'episodevostfr37' => TextHelper::htmlspecialchars($this->get_episodevostfr37()),
			'episodevostfr38' => TextHelper::htmlspecialchars($this->get_episodevostfr38()),
			'episodevostfr39' => TextHelper::htmlspecialchars($this->get_episodevostfr39()),
			'episodevostfr40' => TextHelper::htmlspecialchars($this->get_episodevostfr40()),
			'acteurs' => TextHelper::htmlspecialchars($this->get_acteurs()),
			'statut' => TextHelper::htmlspecialchars($this->get_statut()),
			'duree' => TextHelper::htmlspecialchars($this->get_duree()),
			'annee' => TextHelper::htmlspecialchars($this->get_annee()),
			'rewrited_title' => TextHelper::htmlspecialchars($this->get_rewrited_title()),
			'description' => $this->get_description(),
			'contents' => $this->get_contents(),
			'picture_url' => TextHelper::htmlspecialchars($this->get_picture()->relative()),
			'number_view' => $this->get_number_view(),
			'author_user_id' => $this->get_author_user()->get_id(),
			'author_name_displayed' => $this->get_author_name_displayed(),
			'published' => $this->get_publishing_state(),
			'publishing_start_date' => $this->get_publishing_start_date() !== null ? $this->get_publishing_start_date()->get_timestamp() : '',
			'publishing_end_date' => $this->get_publishing_end_date() !== null ? $this->get_publishing_end_date()->get_timestamp() : '',
			'date_created' => $this->get_date_created()->get_timestamp(),
			'date_updated' => $this->get_date_updated() !== null ? $this->get_date_updated()->get_timestamp() : '',
			'notation_enabled' => $this->get_notation_enabled(),
		);
	}

	public function set_properties(array $properties)
	{
		$this->set_id($properties['id']);
		$this->set_id_category($properties['id_category']);
		$this->set_title($properties['title']);
		$this->set_episode1($properties['episode1']);
		$this->set_episode2($properties['episode2']);
		$this->set_episode3($properties['episode3']);
		$this->set_episode4($properties['episode4']);
		$this->set_episode5($properties['episode5']);
		$this->set_episode6($properties['episode6']);
		$this->set_episode7($properties['episode7']);
		$this->set_episode8($properties['episode8']);
		$this->set_episode9($properties['episode9']);
		$this->set_episode10($properties['episode10']);
		$this->set_episode11($properties['episode11']);
		$this->set_episode12($properties['episode12']);
		$this->set_episode13($properties['episode13']);
		$this->set_episode14($properties['episode14']);
		$this->set_episode15($properties['episode15']);
		$this->set_episode16($properties['episode16']);
		$this->set_episode17($properties['episode17']);
		$this->set_episode18($properties['episode18']);
		$this->set_episode19($properties['episode19']);
		$this->set_episode20($properties['episode20']);
		$this->set_episode21($properties['episode21']);
		$this->set_episode22($properties['episode22']);
		$this->set_episode23($properties['episode23']);
		$this->set_episode24($properties['episode24']);
		$this->set_episode25($properties['episode25']);
		$this->set_episode26($properties['episode26']);
		$this->set_episode27($properties['episode27']);
		$this->set_episode28($properties['episode28']);
		$this->set_episode29($properties['episode29']);
		$this->set_episode30($properties['episode30']);
		$this->set_episode31($properties['episode31']);
		$this->set_episode32($properties['episode32']);
		$this->set_episode33($properties['episode33']);
		$this->set_episode34($properties['episode34']);
		$this->set_episode35($properties['episode35']);
		$this->set_episode36($properties['episode36']);
		$this->set_episode37($properties['episode37']);
		$this->set_episode38($properties['episode38']);
		$this->set_episode39($properties['episode39']);
		$this->set_episode40($properties['episode40']);
		$this->set_episodevostfr1($properties['episodevostfr1']);
		$this->set_episodevostfr2($properties['episodevostfr2']);
		$this->set_episodevostfr3($properties['episodevostfr3']);
		$this->set_episodevostfr4($properties['episodevostfr4']);
		$this->set_episodevostfr5($properties['episodevostfr5']);
		$this->set_episodevostfr6($properties['episodevostfr6']);
		$this->set_episodevostfr7($properties['episodevostfr7']);
		$this->set_episodevostfr8($properties['episodevostfr8']);
		$this->set_episodevostfr9($properties['episodevostfr9']);
		$this->set_episodevostfr10($properties['episodevostfr10']);
		$this->set_episodevostfr11($properties['episodevostfr11']);
		$this->set_episodevostfr12($properties['episodevostfr12']);
		$this->set_episodevostfr13($properties['episodevostfr13']);
		$this->set_episodevostfr14($properties['episodevostfr14']);
		$this->set_episodevostfr15($properties['episodevostfr15']);
		$this->set_episodevostfr16($properties['episodevostfr16']);
		$this->set_episodevostfr17($properties['episodevostfr17']);
		$this->set_episodevostfr18($properties['episodevostfr18']);
		$this->set_episodevostfr19($properties['episodevostfr19']);
		$this->set_episodevostfr20($properties['episodevostfr20']);
		$this->set_episodevostfr21($properties['episodevostfr21']);
		$this->set_episodevostfr22($properties['episodevostfr22']);
		$this->set_episodevostfr23($properties['episodevostfr23']);
		$this->set_episodevostfr24($properties['episodevostfr24']);
		$this->set_episodevostfr25($properties['episodevostfr25']);
		$this->set_episodevostfr26($properties['episodevostfr26']);
		$this->set_episodevostfr27($properties['episodevostfr27']);
		$this->set_episodevostfr28($properties['episodevostfr28']);
		$this->set_episodevostfr29($properties['episodevostfr29']);
		$this->set_episodevostfr30($properties['episodevostfr30']);
		$this->set_episodevostfr31($properties['episodevostfr31']);
		$this->set_episodevostfr32($properties['episodevostfr32']);
		$this->set_episodevostfr33($properties['episodevostfr33']);
		$this->set_episodevostfr34($properties['episodevostfr34']);
		$this->set_episodevostfr35($properties['episodevostfr35']);
		$this->set_episodevostfr36($properties['episodevostfr36']);
		$this->set_episodevostfr37($properties['episodevostfr37']);
		$this->set_episodevostfr38($properties['episodevostfr38']);
		$this->set_episodevostfr39($properties['episodevostfr39']);
		$this->set_episodevostfr40($properties['episodevostfr40']);
		$this->set_acteurs($properties['acteurs']);
		$this->set_duree($properties['duree']);
		$this->set_statut($properties['statut']);
		$this->set_annee($properties['annee']);
		$this->set_rewrited_title($properties['rewrited_title']);
		$this->set_description($properties['description']);
		$this->set_contents($properties['contents']);
		$this->set_picture(new Url($properties['picture_url']));
		$this->set_number_view($properties['number_view']);
		$this->set_author_name_displayed($properties['author_name_displayed']);
		$this->set_publishing_state($properties['published']);
		$this->publishing_start_date = !empty($properties['publishing_start_date']) ? new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $properties['publishing_start_date']) : null;
		$this->publishing_end_date = !empty($properties['publishing_end_date']) ? new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $properties['publishing_end_date']) : null;
		$this->end_date_enabled = !empty($properties['publishing_end_date']);
		$this->set_date_created(new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $properties['date_created']));
		$this->date_updated = !empty($properties['date_updated']) ? new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $properties['date_updated']) : null;
		$this->set_notation_enabled($properties['notation_enabled']);
		
		$user = new User();
		if (!empty($properties['user_id']))
			$user->set_properties($properties);
		else
			$user->init_visitor_user();
			
		$this->set_author_user($user);
		
		$notation = new Notation();
		$notation->set_module_name('series');
		$notation->set_notation_scale(SeriesConfig::load()->get_notation_scale());
		$notation->set_id_in_module($properties['id']);
		$notation->set_number_notes($properties['number_notes']);
		$notation->set_average_notes($properties['average_notes']);
		$notation->set_user_already_noted(!empty($properties['note']));
		$this->notation = $notation;
	}

	public function init_default_properties($id_category = Category::ROOT_CATEGORY)
	{
		$this->id_category = $id_category;
		$this->author_name_displayed = self::AUTHOR_NAME_DISPLAYED;
		$this->published = self::PUBLISHED_NOW;
		$this->publishing_start_date = new Date();
		$this->publishing_end_date = new Date();
		$this->date_created = new Date();
		$this->notation_enabled = self::NOTATION_ENABLED;
		$this->picture_url = new Url(self::DEFAULT_PICTURE);
		$this->number_view = 0;
	}

	public function clean_publishing_start_and_end_date()
	{
		$this->publishing_start_date = null;
		$this->publishing_end_date = null;
		$this->end_date_enabled = false;
	}

	public function clean_publishing_end_date()
	{
		$this->publishing_end_date = null;
		$this->end_date_enabled = false;
	}
	
	public function get_tpl_vars()
	{
		$category = SeriesService::get_categories_manager()->get_categories_cache()->get_category($this->get_id_category());
		$user = $this->get_author_user();
		$user_group_color = User::get_group_color($user->get_groups(), $user->get_level(), true);
		
		return array(
			//Conditions
			'C_EDIT' => $this->is_authorized_edit(),
			'C_DELETE' => $this->is_authorized_delete(),
			'C_HAS_PICTURE' => $this->has_picture(),
			'C_USER_GROUP_COLOR' => !empty($user_group_color),
			'C_PUBLISHED' => $this->is_published(),
			'C_PUBLISHING_START_AND_END_DATE' => $this->publishing_start_date != null && $this->publishing_end_date != null,
			'C_PUBLISHING_START_DATE' => $this->publishing_start_date != null,
			'C_PUBLISHING_END_DATE' => $this->publishing_end_date != null,
			'C_DATE_UPDATED' => $this->date_updated != null,
			'C_AUTHOR_DISPLAYED' => $this->get_author_name_displayed(),
			'C_NOTATION_ENABLED' => $this->get_notation_enabled(),
			'C_EPISODE1' => $this->get_episode1(),
			'C_EPISODE2' => $this->get_episode2(),
			'C_EPISODE3' => $this->get_episode3(),
			'C_EPISODE4' => $this->get_episode4(),
			'C_EPISODE5' => $this->get_episode5(),
			'C_EPISODE6' => $this->get_episode6(),
			'C_EPISODE7' => $this->get_episode7(),
			'C_EPISODE8' => $this->get_episode8(),
			'C_EPISODE9' => $this->get_episode9(),
			'C_EPISODE10' => $this->get_episode10(),
			'C_EPISODE11' => $this->get_episode11(),
			'C_EPISODE12' => $this->get_episode12(),
			'C_EPISODE13' => $this->get_episode13(),
			'C_EPISODE14' => $this->get_episode14(),
			'C_EPISODE15' => $this->get_episode15(),
			'C_EPISODE16' => $this->get_episode16(),
			'C_EPISODE17' => $this->get_episode17(),
			'C_EPISODE18' => $this->get_episode18(),
			'C_EPISODE19' => $this->get_episode19(),
			'C_EPISODE20' => $this->get_episode20(),
			'C_EPISODE21' => $this->get_episode21(),
			'C_EPISODE22' => $this->get_episode22(),
			'C_EPISODE23' => $this->get_episode23(),
			'C_EPISODE24' => $this->get_episode24(),
			'C_EPISODE25' => $this->get_episode25(),
			'C_EPISODE26' => $this->get_episode26(),
			'C_EPISODE27' => $this->get_episode27(),
			'C_EPISODE28' => $this->get_episode28(),
			'C_EPISODE29' => $this->get_episode29(),
			'C_EPISODE30' => $this->get_episode30(),
			'C_EPISODE31' => $this->get_episode31(),
			'C_EPISODE32' => $this->get_episode32(),
			'C_EPISODE33' => $this->get_episode33(),
			'C_EPISODE34' => $this->get_episode34(),
			'C_EPISODE35' => $this->get_episode35(),
			'C_EPISODE36' => $this->get_episode36(),
			'C_EPISODE37' => $this->get_episode37(),
			'C_EPISODE38' => $this->get_episode38(),
			'C_EPISODE39' => $this->get_episode39(),
			'C_EPISODE40' => $this->get_episode40(),
			'C_EPISODEVOSTFR1' => $this->get_episodevostfr1(),
			'C_EPISODEVOSTFR2' => $this->get_episodevostfr2(),
			'C_EPISODEVOSTFR3' => $this->get_episodevostfr3(),
			'C_EPISODEVOSTFR4' => $this->get_episodevostfr4(),
			'C_EPISODEVOSTFR5' => $this->get_episodevostfr5(),
			'C_EPISODEVOSTFR6' => $this->get_episodevostfr6(),
			'C_EPISODEVOSTFR7' => $this->get_episodevostfr7(),
			'C_EPISODEVOSTFR8' => $this->get_episodevostfr8(),
			'C_EPISODEVOSTFR9' => $this->get_episodevostfr9(),
			'C_EPISODEVOSTFR10' => $this->get_episodevostfr10(),
			'C_EPISODEVOSTFR11' => $this->get_episodevostfr11(),
			'C_EPISODEVOSTFR12' => $this->get_episodevostfr12(),
			'C_EPISODEVOSTFR13' => $this->get_episodevostfr13(),
			'C_EPISODEVOSTFR14' => $this->get_episodevostfr14(),
			'C_EPISODEVOSTFR15' => $this->get_episodevostfr15(),
			'C_EPISODEVOSTFR16' => $this->get_episodevostfr16(),
			'C_EPISODEVOSTFR17' => $this->get_episodevostfr17(),
			'C_EPISODEVOSTFR18' => $this->get_episodevostfr18(),
			'C_EPISODEVOSTFR19' => $this->get_episodevostfr19(),
			'C_EPISODEVOSTFR20' => $this->get_episodevostfr20(),
			'C_EPISODEVOSTFR21' => $this->get_episodevostfr21(),
			'C_EPISODEVOSTFR22' => $this->get_episodevostfr22(),
			'C_EPISODEVOSTFR23' => $this->get_episodevostfr23(),
			'C_EPISODEVOSTFR24' => $this->get_episodevostfr24(),
			'C_EPISODEVOSTFR25' => $this->get_episodevostfr25(),
			'C_EPISODEVOSTFR26' => $this->get_episodevostfr26(),
			'C_EPISODEVOSTFR27' => $this->get_episodevostfr27(),
			'C_EPISODEVOSTFR28' => $this->get_episodevostfr28(),
			'C_EPISODEVOSTFR29' => $this->get_episodevostfr29(),
			'C_EPISODEVOSTFR30' => $this->get_episodevostfr30(),
			'C_EPISODEVOSTFR31' => $this->get_episodevostfr31(),
			'C_EPISODEVOSTFR32' => $this->get_episodevostfr32(),
			'C_EPISODEVOSTFR33' => $this->get_episodevostfr33(),
			'C_EPISODEVOSTFR34' => $this->get_episodevostfr34(),
			'C_EPISODEVOSTFR35' => $this->get_episodevostfr35(),
			'C_EPISODEVOSTFR36' => $this->get_episodevostfr36(),
			'C_EPISODEVOSTFR37' => $this->get_episodevostfr37(),
			'C_EPISODEVOSTFR38' => $this->get_episodevostfr38(),
			'C_EPISODEVOSTFR39' => $this->get_episodevostfr39(),
			'C_EPISODEVOSTFR40' => $this->get_episodevostfr40(),
			'C_ACTEURS' => $this->get_acteurs(),
			'C_STATUT' => $this->get_statut(),
			'C_DUREE' => $this->get_duree(),
			'C_ANNEE' => $this->get_annee(),
			
			//Series
			'TITLE' => $this->get_title(),
			'EPISODE1' => $this->get_episode1(),
			'EPISODE2' => $this->get_episode2(),
			'EPISODE3' => $this->get_episode3(),
			'EPISODE4' => $this->get_episode4(),
			'EPISODE5' => $this->get_episode5(),
			'EPISODE6' => $this->get_episode6(),
			'EPISODE7' => $this->get_episode7(),
			'EPISODE8' => $this->get_episode8(),
			'EPISODE9' => $this->get_episode9(),
			'EPISODE10' => $this->get_episode10(),
			'EPISODE11' => $this->get_episode11(),
			'EPISODE12' => $this->get_episode12(),
			'EPISODE13' => $this->get_episode13(),
			'EPISODE14' => $this->get_episode14(),
			'EPISODE15' => $this->get_episode15(),
			'EPISODE16' => $this->get_episode16(),
			'EPISODE17' => $this->get_episode17(),
			'EPISODE18' => $this->get_episode18(),
			'EPISODE19' => $this->get_episode19(),
			'EPISODE20' => $this->get_episode20(),
			'EPISODE21' => $this->get_episode21(),
			'EPISODE22' => $this->get_episode22(),
			'EPISODE23' => $this->get_episode23(),
			'EPISODE24' => $this->get_episode24(),
			'EPISODE25' => $this->get_episode25(),
			'EPISODE26' => $this->get_episode26(),
			'EPISODE27' => $this->get_episode27(),
			'EPISODE28' => $this->get_episode28(),
			'EPISODE29' => $this->get_episode29(),
			'EPISODE30' => $this->get_episode30(),
			'EPISODE31' => $this->get_episode31(),
			'EPISODE32' => $this->get_episode32(),
			'EPISODE33' => $this->get_episode33(),
			'EPISODE34' => $this->get_episode34(),
			'EPISODE35' => $this->get_episode35(),
			'EPISODE36' => $this->get_episode36(),
			'EPISODE37' => $this->get_episode37(),
			'EPISODE38' => $this->get_episode38(),
			'EPISODE39' => $this->get_episode39(),
			'EPISODE40' => $this->get_episode40(),
			'EPISODEVOSTFR1' => $this->get_episodevostfr1(),
			'EPISODEVOSTFR2' => $this->get_episodevostfr2(),
			'EPISODEVOSTFR3' => $this->get_episodevostfr3(),
			'EPISODEVOSTFR4' => $this->get_episodevostfr4(),
			'EPISODEVOSTFR5' => $this->get_episodevostfr5(),
			'EPISODEVOSTFR6' => $this->get_episodevostfr6(),
			'EPISODEVOSTFR7' => $this->get_episodevostfr7(),
			'EPISODEVOSTFR8' => $this->get_episodevostfr8(),
			'EPISODEVOSTFR9' => $this->get_episodevostfr9(),
			'EPISODEVOSTFR10' => $this->get_episodevostfr10(),
			'EPISODEVOSTFR11' => $this->get_episodevostfr11(),
			'EPISODEVOSTFR12' => $this->get_episodevostfr12(),
			'EPISODEVOSTFR13' => $this->get_episodevostfr13(),
			'EPISODEVOSTFR14' => $this->get_episodevostfr14(),
			'EPISODEVOSTFR15' => $this->get_episodevostfr15(),
			'EPISODEVOSTFR16' => $this->get_episodevostfr16(),
			'EPISODEVOSTFR17' => $this->get_episodevostfr17(),
			'EPISODEVOSTFR18' => $this->get_episodevostfr18(),
			'EPISODEVOSTFR19' => $this->get_episodevostfr19(),
			'EPISODEVOSTFR20' => $this->get_episodevostfr20(),
			'EPISODEVOSTFR21' => $this->get_episodevostfr21(),
			'EPISODEVOSTFR22' => $this->get_episodevostfr22(),
			'EPISODEVOSTFR23' => $this->get_episodevostfr23(),
			'EPISODEVOSTFR24' => $this->get_episodevostfr24(),
			'EPISODEVOSTFR25' => $this->get_episodevostfr25(),
			'EPISODEVOSTFR26' => $this->get_episodevostfr26(),
			'EPISODEVOSTFR27' => $this->get_episodevostfr27(),
			'EPISODEVOSTFR28' => $this->get_episodevostfr28(),
			'EPISODEVOSTFR29' => $this->get_episodevostfr29(),
			'EPISODEVOSTFR30' => $this->get_episodevostfr30(),
			'EPISODEVOSTFR31' => $this->get_episodevostfr31(),
			'EPISODEVOSTFR32' => $this->get_episodevostfr32(),
			'EPISODEVOSTFR33' => $this->get_episodevostfr33(),
			'EPISODEVOSTFR34' => $this->get_episodevostfr34(),
			'EPISODEVOSTFR35' => $this->get_episodevostfr35(),
			'EPISODEVOSTFR36' => $this->get_episodevostfr36(),
			'EPISODEVOSTFR37' => $this->get_episodevostfr37(),
			'EPISODEVOSTFR38' => $this->get_episodevostfr38(),
			'EPISODEVOSTFR39' => $this->get_episodevostfr39(),
			'EPISODEVOSTFR40' => $this->get_episodevostfr40(),
			'ACTEURS' => $this->get_acteurs(),
			'STATUT' => $this->get_statut(),
			'DUREE' => $this->get_duree(),
			'ANNEE' => $this->get_annee(),
			'DATE' => $this->get_date_created()->format(Date::FORMAT_DAY_MONTH_YEAR_HOUR_MINUTE_TEXT),
			'DATE_ISO8601' => $this->get_date_created()->format(Date::FORMAT_ISO8601),
			'DATE_SHORT' => $this->get_date_created()->format(Date::FORMAT_DAY_MONTH_YEAR),
			'PUBLISHING_START_DATE' => $this->publishing_start_date != null ? $this->publishing_start_date->format(Date::FORMAT_DAY_MONTH_YEAR_HOUR_MINUTE) : '',
			'PUBLISHING_START_DATE_ISO8601' => $this->publishing_start_date != null ? $this->publishing_start_date->format(Date::FORMAT_ISO8601) : '',
			'PUBLISHING_END_DATE' => $this->publishing_end_date != null ? $this->publishing_end_date->format(Date::FORMAT_DAY_MONTH_YEAR_HOUR_MINUTE) : '',
			'PUBLISHING_END_DATE_ISO8601' => $this->publishing_end_date != null ? $this->publishing_end_date->format(Date::FORMAT_ISO8601) : '',
			'DATE_UPDATED' => $this->date_updated != null ? $this->date_updated->format(Date::FORMAT_DAY_MONTH_YEAR) : '',
			'L_COMMENTS' => CommentsService::get_number_and_lang_comments('series', $this->get_id()),
			'NUMBER_COMMENTS' => CommentsService::get_number_comments('series', $this->get_id()),
			'NUMBER_VIEW' => $this->get_number_view(),
			'NOTE' => $this->get_notation()->get_number_notes() > 0 ? NotationService::display_static_image($this->get_notation()) : '&nbsp;',
			'C_AUTHOR_EXIST' => $user->get_id() !== User::VISITOR_LEVEL,
			'PSEUDO' => $user->get_pseudo(),
			'DESCRIPTION' => $this->get_real_description(),
			'PICTURE' => $this->get_picture()->rel(),
			'USER_LEVEL_CLASS' => UserService::get_level_class($user->get_level()),
			'USER_GROUP_COLOR' => $user_group_color,
			
			//Category
			'CATEGORY_ID' => $category->get_id(),
			'CATEGORY_NAME' => $category->get_name(),
			'CATEGORY_DESCRIPTION' => $category->get_description(),
			'CATEGORY_IMAGE' => $category->get_image(),
			
			//Links
			'U_COMMENTS' => SeriesUrlBuilder::display_comments_serie($category->get_id(), $category->get_rewrited_name(), $this->get_id(), $this->get_rewrited_title())->rel(),
			'U_AUTHOR' => UserUrlBuilder::profile($this->get_author_user()->get_id())->rel(),
			'U_CATEGORY' => SeriesUrlBuilder::display_category($category->get_id(), $category->get_rewrited_name())->rel(),
			'U_SERIE' => SeriesUrlBuilder::display_serie($category->get_id(), $category->get_rewrited_name(), $this->get_id(), $this->get_rewrited_title())->rel(),
			'U_EDIT_SERIE' => SeriesUrlBuilder::edit_serie($this->get_id())->rel(),
			'U_DELETE_SERIE' => SeriesUrlBuilder::delete_serie($this->get_id())->rel(),
			'U_SYNDICATION' => SeriesUrlBuilder::category_syndication($category->get_id())->rel(),
			'U_PRINT_SERIE' => SeriesUrlBuilder::print_serie($this->get_id(), $this->get_rewrited_title())->rel()
		);
	}
}
?>